Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.sql
Interface PreparedStatement

All Superinterfaces:
  Statement

All Known Subinterfaces:
  CallableStatement

public interface PreparedStatement
extends Statement

An object that represents a precompiled SQL statement.

A SQL statement is precompiled and stored in a `PreparedStatement` object. This object can then be used to efficiently execute this statement multiple times.

Note: The setXXX methods for setting IN parameter values must specify types that are compatible with the defined SQL type of the input parameter. For instance, if the IN parameter has SQL type `Integer`, then the method `setInt` should be used.

If arbitrary parameter type conversions are required, the method `setObject` should be used with a target SQL type.
Example of setting a parameter; `con` is an active connection

       PreparedStatement pstmt = con.prepareStatement("UPDATE EMPLOYEES
                                         SET SALARY = ? WHERE ID = ?");
       pstmt.setBigDecimal(1, 153833.00)
       pstmt.setInt(2, 110592)

See Also:
  `Connection.prepareStatement(java.lang.String)`, `

  Some of the methods in this interface are new in the JDBC 2.0 API.

  `

Method Summary
`void` | `addBatch()` Adds a set of parameters to this `PreparedStatement` object's batch of commands.
`void` | `clearParameters()` Clears the current parameter values immediately.
`boolean` | `execute()` Executes any kind of SQL statement.
`ResultSet` | `executeQuery()` Executes the SQL query in this `PreparedStatement` object and returns the result set generated by the query.
`int` | `executeUpdate()` Executes the SQL INSERT, UPDATE or DELETE statement in this `PreparedStatement` object.
`ResultSetMetaData` | `getMetaData()` Gets the number, types and properties of a `ResultSet` object's columns.
`void` | `setArray(int i, Array x)` Sets the designated parameter to the given `Array` object.
`void` | `setAsciiStream(int parameterIndex, InputStream x, int length)` Sets the designated parameter to the given input stream, which will have the specified number of bytes.
`void` | `setBigDecimal(int parameterIndex, BigDecimal x)` Sets the designated parameter to a `java.math.BigDecimal` value.
`void` | `setBinaryStream(int parameterIndex, InputStream x, int length)` Sets the designated parameter to the given input stream, which will have the specified number of bytes.
`void` | `setBlob(int i, Blob x)` Sets the designated parameter to the given `Blob` object.
`void` | `setBoolean(int parameterIndex, boolean x)` Sets the designated parameter to a Java `boolean` value.
`void` | `setByte(int parameterIndex, byte x)` Sets the designated parameter to a Java `byte` value.
`void` | `setBytes(int parameterIndex, byte[] x)` Sets the designated parameter to a Java array of bytes.
`void` | `setCharacterStream(int parameterIndex, Reader reader, int length)` Sets the designated parameter to the given `Reader` object, which is the given number of characters long.
`void` | `setClob(int i, Clob x)` Sets the designated parameter to the given `Clob` object.
`void` | `setDate(int parameterIndex, Date x)` Sets the designated parameter to a value.
`void` | `setDate(int parameterIndex, Date x, Calendar cal)` Sets the designated parameter to the given `java.sql.Date` value, using the given `Calendar` object.
`void` | `setDouble(int parameterIndex, double x)` Sets the designated parameter to a Java `double` value.
`void` | `setFloat(int parameterIndex, float x)` Sets the designated parameter to a Java `float` value.
`void` | `setInt(int parameterIndex, int x)` Sets the designated parameter to a Java `int` value.
`void` | `setLong(int parameterIndex, long x)` Sets the designated parameter to a Java `long` value.
`void` | `setNull(int parameterIndex, int sqlType)` Sets the designated parameter to SQL `NULL`.
`void` | `setNull(int paramIndex, int sqlType, String typeName)` Sets the designated parameter to SQL `NULL`.
`void` | `setObject(int parameterIndex, Object x)` Sets the value of the designated parameter using the given object.
`void` | `setObject(int parameterIndex, Object x, int targetSqlType)` Sets the value of the designated parameter with the given object.
`void` | `setObject(int parameterIndex, Object x, int targetSqlType, int scale)` Sets the value of the designated parameter with the given object.
`void` | `setRef(int i, Ref x)` Sets the designated parameter to the given `REF(<structured-type>)` value.
`void` | `setShort(int parameterIndex, short x)` Sets the designated parameter to a Java `short` value.
`void` | `setString(int parameterIndex, String x)` Sets the designated parameter to a Java `String` value.
`void` | `setTime(int parameterIndex, Time x)` Sets the designated parameter to a `java.sql.Time` value.
`void` | `setTime(int parameterIndex, Time x, Calendar cal)` Sets the designated parameter to the given `java.sql.Time` value, using the given `Calendar` object.
`void` | `setTimestamp(int parameterIndex, Timestamp x)` Sets the designated parameter to a `java.sql.Timestamp` value.
`void` | `setTimestamp(int parameterIndex, Timestamp x, Calendar cal)` Sets the designated parameter to the given `java.sql.Timestamp` value, using the given `Calendar` object.
`void` | `setUnicodeStream(int parameterIndex, InputStream x, int length)` Deprecated.

Methods inherited from interface java.sql.Statement
`addBatch, cancel, clearBatch, clearWarnings, close, execute, executeBatch, executeQuery, executeUpdate, getConnection, getFetchDirection, getFetchSize, getMaxFieldSize, getMaxRows, getMoreResults, getQueryTimeout, getResultSet, getResultSetConcurrency, getResultSetType, getUpdateCount, getWarnings, setCursorName, setEscapeProcessing, setFetchDirection, setFetchSize, setMaxFieldSize, setMaxRows, setQueryTimeout`

Method Detail

### executeQuery

    public ResultSet executeQuery()
                           throws SQLException

  Executes the SQL query in this `PreparedStatement` object and returns the result set generated by the query.
  Returns:
    a `ResultSet` object that contains the data produced by the query; never `null`
  Throws:
    `SQLException` - if a database access error occurs

### executeUpdate

    public int executeUpdate()
                      throws SQLException

  Executes the SQL INSERT, UPDATE or DELETE statement in this `PreparedStatement` object. In addition, SQL statements that return nothing, such as SQL DDL statements, can be executed.
  Returns:
    either the row count for INSERT, UPDATE or DELETE statements; or 0 for SQL statements that return nothing
  Throws:
    `SQLException` - if a database access error occurs

### setNull

    public void setNull(int parameterIndex,
                        int sqlType)
                 throws SQLException

  Sets the designated parameter to SQL `NULL`.

  Note: You must specify the parameter's SQL type.

  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `sqlType` - the SQL type code defined in `java.sql.Types`
  Throws:
    `SQLException` - if a database access error occurs

### setBoolean

    public void setBoolean(int parameterIndex,
                           boolean x)
                    throws SQLException

  Sets the designated parameter to a Java `boolean` value. The driver converts this to an SQL `BIT` value when it sends it to the database.
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value
  Throws:
    `SQLException` - if a database access error occurs

### setByte

    public void setByte(int parameterIndex,
                        byte x)
                 throws SQLException

  Sets the designated parameter to a Java `byte` value. The driver converts this to an SQL `TINYINT` value when it sends it to the database.
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value
  Throws:
    `SQLException` - if a database access error occurs

### setShort

    public void setShort(int parameterIndex,
                         short x)
                  throws SQLException

  Sets the designated parameter to a Java `short` value. The driver converts this to an SQL `SMALLINT` value when it sends it to the database.
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value
  Throws:
    `SQLException` - if a database access error occurs

### setInt

    public void setInt(int parameterIndex,
                       int x)
                throws SQLException

  Sets the designated parameter to a Java `int` value. The driver converts this to an SQL `INTEGER` value when it sends it to the database.
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value
  Throws:
    `SQLException` - if a database access error occurs

### setLong

    public void setLong(int parameterIndex,
                        long x)
                 throws SQLException

  Sets the designated parameter to a Java `long` value. The driver converts this to an SQL `BIGINT` value when it sends it to the database.
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value
  Throws:
    `SQLException` - if a database access error occurs

### setFloat

    public void setFloat(int parameterIndex,
                         float x)
                  throws SQLException

  Sets the designated parameter to a Java `float` value. The driver converts this to an SQL `FLOAT` value when it sends it to the database.
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value
  Throws:
    `SQLException` - if a database access error occurs

### setDouble

    public void setDouble(int parameterIndex,
                          double x)
                   throws SQLException

  Sets the designated parameter to a Java `double` value. The driver converts this to an SQL `DOUBLE` value when it sends it to the database.
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value
  Throws:
    `SQLException` - if a database access error occurs

### setBigDecimal

    public void setBigDecimal(int parameterIndex,
                              BigDecimal x)
                       throws SQLException

  Sets the designated parameter to a `java.math.BigDecimal` value. The driver converts this to an SQL `NUMERIC` value when it sends it to the database.
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value
  Throws:
    `SQLException` - if a database access error occurs

### setString

    public void setString(int parameterIndex,
                          String x)
                   throws SQLException

  Sets the designated parameter to a Java `String` value. The driver converts this to an SQL `VARCHAR` or `LONGVARCHAR` value (depending on the argument's size relative to the driver's limits on `VARCHAR` values) when it sends it to the database.
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value
  Throws:
    `SQLException` - if a database access error occurs

### setBytes

    public void setBytes(int parameterIndex,
                         byte[] x)
                  throws SQLException

  Sets the designated parameter to a Java array of bytes. The driver converts this to an SQL `VARBINARY` or `LONGVARBINARY` (depending on the argument's size relative to the driver's limits on `VARBINARY` values) when it sends it to the database.
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value
  Throws:
    `SQLException` - if a database access error occurs

### setDate

    public void setDate(int parameterIndex,
                        Date x)
                 throws SQLException

  Sets the designated parameter to a value. The driver converts this to an SQL `DATE` value when it sends it to the database.
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value
  Throws:
    `SQLException` - if a database access error occurs

### setTime

    public void setTime(int parameterIndex,
                        Time x)
                 throws SQLException

  Sets the designated parameter to a `java.sql.Time` value. The driver converts this to an SQL `TIME` value when it sends it to the database.
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value
  Throws:
    `SQLException` - if a database access error occurs

### setTimestamp

    public void setTimestamp(int parameterIndex,
                             Timestamp x)
                      throws SQLException

  Sets the designated parameter to a `java.sql.Timestamp` value. The driver converts this to an SQL `TIMESTAMP` value when it sends it to the database.
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value
  Throws:
    `SQLException` - if a database access error occurs

### setAsciiStream

    public void setAsciiStream(int parameterIndex,
                               InputStream x,
                               int length)
                        throws SQLException

  Sets the designated parameter to the given input stream, which will have the specified number of bytes. When a very large ASCII value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.InputStream`. Data will be read from the stream as needed until end-of-file is reached. The JDBC driver will do any necessary conversion from ASCII to the database char format.

  Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the Java input stream that contains the ASCII parameter value
    `length` - the number of bytes in the stream
  Throws:
    `SQLException` - if a database access error occurs

### setUnicodeStream

    public void setUnicodeStream(int parameterIndex,
                                 InputStream x,
                                 int length)
                          throws SQLException

  Deprecated.

  Sets the designated parameter to the given input stream, which will have the specified number of bytes. When a very large UNICODE value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.InputStream` object. The data will be read from the stream as needed until end-of-file is reached. The JDBC driver will do any necessary conversion from UNICODE to the database char format. The byte format of the Unicode stream must be Java UTF-8, as defined in the Java Virtual Machine Specification.

  Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the java input stream which contains the UNICODE parameter value
    `length` - the number of bytes in the stream
  Throws:
    `SQLException` - if a database access error occurs

### setBinaryStream

    public void setBinaryStream(int parameterIndex,
                                InputStream x,
                                int length)
                         throws SQLException

  Sets the designated parameter to the given input stream, which will have the specified number of bytes. When a very large binary value is input to a `LONGVARBINARY` parameter, it may be more practical to send it via a `java.io.InputStream` object. The data will be read from the stream as needed until end-of-file is reached.

  Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the java input stream which contains the binary parameter value
    `length` - the number of bytes in the stream
  Throws:
    `SQLException` - if a database access error occurs

### clearParameters

    public void clearParameters()
                         throws SQLException

  Clears the current parameter values immediately.

  In general, parameter values remain in force for repeated use of a statement. Setting a parameter value automatically clears its previous value. However, in some cases it is useful to immediately release the resources used by the current parameter values; this can be done by calling the method `clearParameters`.

  Throws:
    `SQLException` - if a database access error occurs

### setObject

    public void setObject(int parameterIndex,
                          Object x,
                          int targetSqlType,
                          int scale)
                   throws SQLException

  Sets the value of the designated parameter with the given object. The second argument must be an object type; for integral values, the `java.lang` equivalent objects should be used.

  The given Java object will be converted to the given targetSqlType before being sent to the database. If the object has a custom mapping (is of a class implementing the interface `SQLData`), the JDBC driver should call the method `SQLData.writeSQL` to write it to the SQL data stream. If, on the other hand, the object is of a class implementing Ref, Blob, Clob, Struct, or Array, the driver should pass it to the database as a value of the corresponding SQL type.

  Note that this method may be used to pass datatabase- specific abstract data types.

  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the object containing the input parameter value
    `targetSqlType` - the SQL type (as defined in java.sql.Types) to be sent to the database. The scale argument may further qualify this type.
    `scale` - for java.sql.Types.DECIMAL or java.sql.Types.NUMERIC types, this is the number of digits after the decimal point. For all other types, this value will be ignored.
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `Types`

### setObject

    public void setObject(int parameterIndex,
                          Object x,
                          int targetSqlType)
                   throws SQLException

  Sets the value of the designated parameter with the given object. This method is like the method `setObject` above, except that it assumes a scale of zero.
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the object containing the input parameter value
    `targetSqlType` - the SQL type (as defined in java.sql.Types) to be sent to the database
  Throws:
    `SQLException` - if a database access error occurs

### setObject

    public void setObject(int parameterIndex,
                          Object x)
                   throws SQLException

  Sets the value of the designated parameter using the given object. The second parameter must be of type `Object`; therefore, the `java.lang` equivalent objects should be used for built-in types.

  The JDBC specification specifies a standard mapping from Java `Object` types to SQL types. The given argument will be converted to the corresponding SQL type before being sent to the database.

  Note that this method may be used to pass datatabase- specific abstract data types, by using a driver-specific Java type. If the object is of a class implementing the interface `SQLData`, the JDBC driver should call the method `SQLData.writeSQL` to write it to the SQL data stream. If, on the other hand, the object is of a class implementing Ref, Blob, Clob, Struct, or Array, then the driver should pass it to the database as a value of the corresponding SQL type. This method throws an exception if there is an ambiguity, for example, if the object is of a class implementing more than one of the interfaces named above.

  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the object containing the input parameter value
  Throws:
    `SQLException` - if a database access error occurs

### execute

    public boolean execute()
                    throws SQLException

  Executes any kind of SQL statement. Some prepared statements return multiple results; the `execute` method handles these complex statements as well as the simpler form of statements handled by the methods `executeQuery` and `executeUpdate`.
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `Statement.execute(java.lang.String)`

### addBatch

    public void addBatch()
                  throws SQLException

  Adds a set of parameters to this `PreparedStatement` object's batch of commands.
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.2
  See Also:
    `Statement.addBatch(java.lang.String)`, What Is in the JDBC 2.0 API

### setCharacterStream

    public void setCharacterStream(int parameterIndex,
                                   Reader reader,
                                   int length)
                            throws SQLException

  Sets the designated parameter to the given `Reader` object, which is the given number of characters long. When a very large UNICODE value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.Reader` object. The data will be read from the stream as needed until end-of-file is reached. The JDBC driver will do any necessary conversion from UNICODE to the database char format.

  Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the java reader which contains the UNICODE data
    `length` - the number of characters in the stream
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### setRef

    public void setRef(int i,
                       Ref x)
                throws SQLException

  Sets the designated parameter to the given `REF(<structured-type>)` value.
  Parameters:
    `i` - the first parameter is 1, the second is 2, ...
    `x` - an SQL `REF` value
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### setBlob

    public void setBlob(int i,
                        Blob x)
                 throws SQLException

  Sets the designated parameter to the given `Blob` object.
  Parameters:
    `i` - the first parameter is 1, the second is 2, ...
    `x` - a `Blob` object that maps an SQL `BLOB` value
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### setClob

    public void setClob(int i,
                        Clob x)
                 throws SQLException

  Sets the designated parameter to the given `Clob` object.
  Parameters:
    `i` - the first parameter is 1, the second is 2, ...
    `x` - a `Clob` object that maps an SQL `CLOB` value
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### setArray

    public void setArray(int i,
                         Array x)
                  throws SQLException

  Sets the designated parameter to the given `Array` object. Sets an Array parameter.
  Parameters:
    `i` - the first parameter is 1, the second is 2, ...
    `x` - an `Array` object that maps an SQL `ARRAY` value
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### getMetaData

    public ResultSetMetaData getMetaData()
                                  throws SQLException

  Gets the number, types and properties of a `ResultSet` object's columns.
  Returns:
    the description of a `ResultSet` object's columns
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### setDate

    public void setDate(int parameterIndex,
                        Date x,
                        Calendar cal)
                 throws SQLException

  Sets the designated parameter to the given `java.sql.Date` value, using the given `Calendar` object. The driver uses the `Calendar` object to construct an SQL `DATE` value, which the driver then sends to the database. With a a `Calendar` object, the driver can calculate the date taking into account a custom timezone. If no `Calendar` object is specified, the driver uses the default timezone, which is that of the virtual machine running the application.
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value
    `cal` - the `Calendar` object the driver will use to construct the date
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### setTime

    public void setTime(int parameterIndex,
                        Time x,
                        Calendar cal)
                 throws SQLException

  Sets the designated parameter to the given `java.sql.Time` value, using the given `Calendar` object. The driver uses the `Calendar` object to construct an SQL `TIME` value, which the driver then sends to the database. With a a `Calendar` object, the driver can calculate the time taking into account a custom timezone. If no `Calendar` object is specified, the driver uses the default timezone, which is that of the virtual machine running the application.
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value
    `cal` - the `Calendar` object the driver will use to construct the time
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### setTimestamp

    public void setTimestamp(int parameterIndex,
                             Timestamp x,
                             Calendar cal)
                      throws SQLException

  Sets the designated parameter to the given `java.sql.Timestamp` value, using the given `Calendar` object. The driver uses the `Calendar` object to construct an SQL `TIMESTAMP` value, which the driver then sends to the database. With a a `Calendar` object, the driver can calculate the timestamp taking into account a custom timezone. If no `Calendar` object is specified, the driver uses the default timezone, which is that of the virtual machine running the application.
  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `x` - the parameter value
    `cal` - the `Calendar` object the driver will use to construct the timestamp
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### setNull

    public void setNull(int paramIndex,
                        int sqlType,
                        String typeName)
                 throws SQLException

  Sets the designated parameter to SQL `NULL`. This version of the method `setNull` should be used for user-defined types and REF type parameters. Examples of user-defined types include: STRUCT, DISTINCT, JAVA_OBJECT, and named array types.

  Note: To be portable, applications must give the SQL type code and the fully-qualified SQL type name when specifying a NULL user-defined or REF parameter. In the case of a user-defined type the name is the type name of the parameter itself. For a REF parameter, the name is the type name of the referenced type. If a JDBC driver does not need the type code or type name information, it may ignore it. Although it is intended for user-defined and Ref parameters, this method may be used to set a null parameter of any JDBC type. If the parameter does not have a user-defined or REF type, the given typeName is ignored.

  Parameters:
    `parameterIndex` - the first parameter is 1, the second is 2, ...
    `sqlType` - a value from `java.sql.Types`
    `typeName` - the fully-qualified name of an SQL user-defined type; ignored if the parameter is not a user-defined type or REF
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.